#GIT_CMT=692a8b89b9a76cdaa61267e01e73272d75f89b18
#
# Spec file for Oracle Storage Mingration Daemon
#

Summary: Binary, Library for Oracle Storage Migration
Name: osmd
Version: 0.9
Release: 22%{?dist}
Group:	System Environment/Base
License: GPLv2
Source0: osmd-0.9.tar.bz2
Packager: Srinivas Eeda <srinivas.eeda@oracle.com>
Vendor: Oracle America
BuildRequires: glibc glib2-devel

BuildRoot: %{name}-%{version}

%description -n osmd
osmd contains binary, init scripts and shared library

%package devel
Summary: Hearder files for Oracle Storage Migration library
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
Header files for Oracle Storage Migration library

%package test
Summary: Storage Migration Test scripts
Version: 0.9
Release: 11%{?dist}

%description test
Storage Migration Test files

%prep
%setup -n osmd-%{version}

%build
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/init.d
mkdir -p $RPM_BUILD_ROOT/usr/sbin/
mkdir -p $RPM_BUILD_ROOT/usr/lib64/
mkdir -p $RPM_BUILD_ROOT/usr/include/
mkdir -p $RPM_BUILD_ROOT/opt/osmd-test/
mkdir -p $RPM_BUILD_ROOT/opt/osmd-test/bin
mkdir -p $RPM_BUILD_ROOT/opt/osmd-test/scripts
mkdir -p $RPM_BUILD_ROOT/opt/osmd-test/utils

install --mode=755 util/osmd.init $RPM_BUILD_ROOT/etc/init.d/osmd
install --mode=755 daemon/osmdaemon $RPM_BUILD_ROOT/usr/sbin/
install --mode=755 lib/libosm.so $RPM_BUILD_ROOT/usr/lib64/
install --mode=644 include/osmlib.h $RPM_BUILD_ROOT/usr/include/

install --mode=755 test/osmltest $RPM_BUILD_ROOT/opt/osmd-test/bin/osmltest
install --mode=755 test/osmdtest $RPM_BUILD_ROOT/opt/osmd-test/bin/osmdtest
install --mode=755 test/oftest   $RPM_BUILD_ROOT/opt/osmd-test/bin/oftest
install --mode=755 test/prep.sh $RPM_BUILD_ROOT/opt/osmd-test/prep.sh
install --mode=755 test/testtools.sh $RPM_BUILD_ROOT/opt/osmd-test/testtools.sh
install --mode=755 test/long_regress.sh $RPM_BUILD_ROOT/opt/osmd-test/long_regress.sh
install --mode=755 test/short_regress.sh $RPM_BUILD_ROOT/opt/osmd-test/short_regress.sh
install --mode=755 test/scripts/bidir_big.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/bidir_big.sh
install --mode=755 test/scripts/all.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/all.sh
install --mode=755 test/scripts/bidir_zero.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/bidir_zero.sh
install --mode=755 test/scripts/bounce.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/bounce.sh
install --mode=755 test/scripts/hotbounce.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/hotbounce.sh
install --mode=755 test/scripts/big.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/big.sh
install --mode=755 test/scripts/bidir_hotmig.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/bidir_hotmig.sh
install --mode=755 test/scripts/bidir_all_remote.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/bidir_all_remote.sh
install --mode=755 test/scripts/multiple_big.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/multiple_big.sh
install --mode=755 test/scripts/hotbounce_remote.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/hotbounce_remote.sh
install --mode=755 test/scripts/bidir_small.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/bidir_small.sh
install --mode=755 test/scripts/zero.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/zero.sh
install --mode=755 test/scripts/multiple_bounce.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/multiple_bounce.sh
install --mode=755 test/scripts/bidir_small_remote.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/bidir_small_remote.sh
install --mode=755 test/scripts/multiple_hotbounce_remote.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/multiple_hotbounce_remote.sh
install --mode=755 test/scripts/bidir_all.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/bidir_all.sh
install --mode=755 test/scripts/hotmig.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/hotmig.sh
install --mode=755 test/scripts/multiple_zero.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/multiple_zero.sh
install --mode=755 test/scripts/multiple_bounce_remote.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/multiple_bounce_remote.sh
install --mode=755 test/scripts/small.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/small.sh
install --mode=755 test/scripts/bidir_big_remote.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/bidir_big_remote.sh
install --mode=755 test/scripts/bounce_remote.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/bounce_remote.sh
install --mode=755 test/scripts/multiple_hotmig.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/multiple_hotmig.sh
install --mode=755 test/scripts/multiple_small.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/multiple_small.sh
install --mode=755 test/scripts/multiple_all.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/multiple_all.sh
install --mode=755 test/scripts/multiple_hotbounce.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/multiple_hotbounce.sh
install --mode=755 test/scripts/bidir_zero_remote.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/bidir_zero_remote.sh
install --mode=755 test/scripts/bidir_hotmig_remote.sh $RPM_BUILD_ROOT/opt/osmd-test/scripts/bidir_hotmig_remote.sh
install --mode=755 test/utils/md5sum.sh $RPM_BUILD_ROOT/opt/osmd-test/utils/md5sum.sh
install --mode=755 test/utils/daemon.sh $RPM_BUILD_ROOT/opt/osmd-test/utils/daemon.sh
install --mode=755 test/utils/create_files.sh $RPM_BUILD_ROOT/opt/osmd-test/utils/create_files.sh
install --mode=755 test/utils/validate.sh $RPM_BUILD_ROOT/opt/osmd-test/utils/validate.sh
install --mode=755 test/utils/hotfile.sh $RPM_BUILD_ROOT/opt/osmd-test/utils/hotfile.sh
install --mode=755 test/README.txt $RPM_BUILD_ROOT/opt/osmd-test/README.txt

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add osmd >/dev/null
/sbin/ldconfig

%preun
if [ $1 = 0 ]; then
   /sbin/service osmd stop > /dev/null 2>&1
   /sbin/chkconfig --del osmd
fi
/sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc COPYING README
/usr/sbin/osmdaemon
/usr/lib64/libosm.so
/etc/init.d/osmd

%files devel
%defattr(-,root,root,-)
/usr/include/osmlib.h

%files test
%defattr(-,root,root,-)
/opt/osmd-test/bin/osmltest
/opt/osmd-test/bin/osmdtest
/opt/osmd-test/bin/oftest
/opt/osmd-test/prep.sh
/opt/osmd-test/testtools.sh
/opt/osmd-test/long_regress.sh
/opt/osmd-test/short_regress.sh
/opt/osmd-test/scripts/bidir_big.sh
/opt/osmd-test/scripts/all.sh
/opt/osmd-test/scripts/bidir_zero.sh
/opt/osmd-test/scripts/bounce.sh
/opt/osmd-test/scripts/hotbounce.sh
/opt/osmd-test/scripts/big.sh
/opt/osmd-test/scripts/bidir_hotmig.sh
/opt/osmd-test/scripts/bidir_all_remote.sh
/opt/osmd-test/scripts/multiple_big.sh
/opt/osmd-test/scripts/hotbounce_remote.sh
/opt/osmd-test/scripts/bidir_small.sh
/opt/osmd-test/scripts/zero.sh
/opt/osmd-test/scripts/multiple_bounce.sh
/opt/osmd-test/scripts/bidir_small_remote.sh
/opt/osmd-test/scripts/multiple_hotbounce_remote.sh
/opt/osmd-test/scripts/bidir_all.sh
/opt/osmd-test/scripts/hotmig.sh
/opt/osmd-test/scripts/multiple_zero.sh
/opt/osmd-test/scripts/multiple_bounce_remote.sh
/opt/osmd-test/scripts/small.sh
/opt/osmd-test/scripts/bidir_big_remote.sh
/opt/osmd-test/scripts/bounce_remote.sh
/opt/osmd-test/scripts/multiple_hotmig.sh
/opt/osmd-test/scripts/multiple_small.sh
/opt/osmd-test/scripts/multiple_all.sh
/opt/osmd-test/scripts/multiple_hotbounce.sh
/opt/osmd-test/scripts/bidir_zero_remote.sh
/opt/osmd-test/scripts/bidir_hotmig_remote.sh
/opt/osmd-test/utils/md5sum.sh
/opt/osmd-test/utils/daemon.sh
/opt/osmd-test/utils/create_files.sh
/opt/osmd-test/utils/validate.sh
/opt/osmd-test/utils/hotfile.sh
/opt/osmd-test/README.txt

%changelog
* Thu Dec 17 2015 Srinivas Eeda <srinivas.eeda@oracle.com> - 0.9-22
- 64 bit integer to calculate the remaining bytes of an extent (Srinivas Eeda)

* Tue Oct 13 2015 Srinivas Eeda <srinivas.eeda@oracle.com> - 0.9-21
- osmd up version (Srinivas Eeda)  
- reverting the o_direct strict checking (Manjunath Patil)  
- Library returns unrelated error message in case of pread error (Manjunath Patil)  
- README changes and osml config changes (Manjunath Patil)  
- Mark unwritten extent as read (Manjunath Patil)  
- test only change: remove duplicate lib calls in library (Manjunath Patil)

* Wed Aug 19 2015 Srinivas Eeda <srinivas.eeda@oracle.com> - 0.9-20
- osmd up version (Srinivas Eeda)

* Wed Aug 19 2015 Manjunath Patil <manjunath.b.patil@oracle.com> - 0.9-19_Bug21613871_debug01
- Memory leak fixes in library code. (Manjunath Patil)  
- Enable osml logging (Manjunath Patil)  
- pread fails with -EIO which leads slm to hung (Manjunath Patil)  
- O_DIRECT changes02 (Manjunath Patil)  
- Double start of daemon invalidates unix socket (Manjunath Patil)  
- remove_older_code_in_testscript (Manjunath Patil)  
- socket_status_change_at_recv_send (Manjunath Patil)  
- ssh/scp with no host key check (Manjunath Patil)  
- osmd mark extent as read when parsing unwritten extent (Srinivas Eeda)

* Tue Aug 04 2015 Srinivas Eeda <srinivas.eeda@oracle.com> - 0.9-18
- osmd enable direct IO's to reduce caching (Srinivas Eeda)

* Wed Jul 22 2015 Srinivas Eeda <srinivas.eeda@oracle.com> - 0.9-17
- osml remove migration context from list on error (Srinivas Eeda)

* Mon Jul 13 2015 Srinivas Eeda <srinivas.eeda@oracle.com> - 0.9-16
- osmd fix double socket close (Srinivas Eeda)

* Tue Jun 23 2015 Srinivas Eeda <srinivas.eeda@oracle.com> - 0.9-15.1
- osmd send hb message (Srinivas Eeda)

* Wed Jun 17 2015 Srinivas Eeda <srinivas.eeda@oracle.com> - 0.9-14
- osmd delete if reflink file exist (Srinivas Eeda)

* Tue Jun 16 2015 Srinivas Eeda <srinivas.eeda@oracle.com> - 0.9-13
- osmd add README (Srinivas Eeda)

* Tue Jun 16 2015 Srinivas Eeda <srinivas.eeda@oracle.com> - 0.9-12
- osmd bump version (Srinivas Eeda)  
- osmd stop msg by osmd.ini (Srinivas Eeda)  
- osmd cmd_args_to_retain_snapshot (Srinivas Eeda)  
- osmd kill_copy_pid_in_hot_migs (Srinivas Eeda)  
- osmd fix maintainer file (Srinivas Eeda)

* Fri Jun 05 2015 Srinivas Eeda <srinivas.eeda@oracle.com> - 0.9-11
- osmd bump version (Srinivas Eeda)  
- osmd remove generic kill from hotmigs (Srinivas Eeda)  
- osmltest_changes_custom_sock_path (Srinivas Eeda)  
- osmd add new test file (Srinivas Eeda)  
- osmd allow configure values (Srinivas Eeda)  
- osmd set default values in sysconfig osmd (Srinivas Eeda)  
- osmd-disable default lib logging (Srinivas Eeda)

* Fri May 29 2015 Srinivas Eeda <srinivas.eeda@oracle.com> - 0.9-10
- osmd bump build ersion (Srinivas Eeda)  
- osmd BOUNCE_REMOTE_OUT_to_REMOTE_OUT (Srinivas Eeda)  
- osmd check_osmd_config_file_test_cases (Srinivas Eeda)  
- osmd fix_bounce_with_nodaemon (Srinivas Eeda)  
- osmd fix default log file name (Srinivas Eeda)  
- Signed-off-by: Srinivas Eeda <srinivas.eeda@oracle.com> (Srinivas Eeda)  
- osmd fix_missing_config_daemon_fail   * check the exitence of file before trying to parse (Srinivas Eeda)  
- osmd add missing test files (Srinivas Eeda)  
- osmd loglevel_to_log_level  * change config file entry of LOGLEVEL to LOG_LEVEL  * change config file entry of LOGFILE to LOG_FILE  * osmltest.c errors to stderr (Srinivas Eeda)  
- osmd daemon_config_validations   * null values are valid and imply default values   * range validation for values   * network buf size and disk buf size variable addition   * osm_get_net_buf_sz() osm_get_dsk_buf_sz() APIs   * stick config struct(ocf) to main ctxt   * addition of osmdaemon start and stop messages irrespective of loglevel (Srinivas Eeda)  
- osmd include vdbench test suite (Srinivas Eeda)  
- osmd fix_long_regress_renaming (Srinivas Eeda)

* Tue May 26 2015 Srinivas Eeda <srinivas.eeda@oracle.com> - 0.9-9.el6
- osmd bump version   osmd-0.9-9   osmd-test-0.9-6 Signed-off-by: Srinivas Eeda <srinivas.eeda@oracle.com> (Srinivas Eeda)  
- osmd ssh error check as string  * check the output of ssh as string rather than integer  * guilt rm utils/parse.sh  * guilt rm test/utils/scp_to.exp  * guilt rm test/utils/scp_from.exp  * guilt rm test/utils/ssh.exp (Srinivas Eeda)  
- osmd replace ssh.exp to ssh   * since passwd is not required for ssh now, we dont need expect script   * remove scp_to.exp and scp_from.exp similarly (Srinivas Eeda)  
- osmd remove local ssh  * Remove the unnecessary local ssh in test scripts  * minor typo correction for bidir_all_remote.sh  * removal of extra call to remote script in hotbounce.sh (Srinivas Eeda)  
- osmd log migration begin and end (Srinivas Eeda)  
- osmd test cases should ask for passwds (Srinivas Eeda)  
- osmd default SRC_TEST_HOME to /opt/osmd-test (Srinivas Eeda)  
- osmd daemonize option through command line arg (Srinivas Eeda)  
- osmd minimal logging by default (Srinivas Eeda)  
- osmd fix osmd logging (Srinivas Eeda)  
- osmd fix daemon hang when end followed abort (Srinivas Eeda)  
- patch osmd-fix-gpl-tag.patch (Srinivas Eeda)  
- osmd fix oftest test case (Srinivas Eeda)  
- osmd create bin directory for test code   - add prep.sh (Srinivas Eeda)  
- osmd fix test scripts (Srinivas Eeda)  
- osmd fix ret variable type (Srinivas Eeda)

* Wed May 20 2015 Srinivas Eeda <srinivas.eeda@oracle.com> - 0.9-8.el6
- osmd fix requries glib2-devel (Srinivas Eeda)  
- osmd fix test suite   - removed hardcoded ip address   - fixed osmd-test rpm name (Srinivas Eeda)  
- osmd fix build rpm (Srinivas Eeda)  
- osmd fix Vendor name Signed-off-by: Srinivas Eeda <srinivas.eeda@oracle.com> (Srinivas Eeda)  
- Signed-off-by: Srinivas Eeda <srinivas.eeda@oracle.com> (Srinivas Eeda)  
- osmd bump module version (Srinivas Eeda)  
- osmd create osmd test rpm (Srinivas Eeda)  
- osmd add GPL v2 license (Srinivas Eeda)  
- osmd fix osmd test suite (Srinivas Eeda)  
- osmd-fix-daemonize (Srinivas Eeda)  
- osmd bug fixes patch (Srinivas Eeda)  
- osml library doesnt need to validate file (Srinivas Eeda)  
- osmd free temp buffer on release (Srinivas Eeda)

* Thu Apr 30 2015 Srinivas Eeda <srinivas.eeda@oracle.com> 0.9-5
- memory leaks in omsdfile
- close to fclose in osmconfig
- mig_task not found bug (seqno:0)
- update master thread list by listener when master exits
- enable pthread_joins to avoid memory leaks

* Mon Apr 27 2015 Zhigang Wang <zhigang.x.wang@oracle.com> 0.9-4
- generate devel rpm
- fix log level
- fix log file destination

* Thu Apr 23 2015 Tianyue Lan <tianyue.lan@oracle.com> - 0.9-3
- osmd fix osmd-error and osml-error
  Signed-off-by: Srinivas Eeda <srinivas.eeda@oracle.com>

* Thu Apr 23 2015 Tianyue Lan <tianyue.lan@oracle.com> - 0.9-2
- osmd fix osmltest compile error
  Signed-off-by: Srinivas Eeda <srinivas.eeda@oracle.com>

* Fri Apr 17 2015 Srinivas Eeda <srinivas.eeda@oracle.com> 0.9-1
- Oracle Storage Migration beta

